#include "x86.h"
#include "os.h"

/*****************************************************************************
 * p2
    пароль читается по одному символу за раз
 
 
  из "pipe  buffer" в локальную переменную  (buf[].
  Прочитанный результат сравнивается с "good_password".
  В случае успеха на экран выводится "Y" 
 *****************************************************************************/

char good_password[] = "111";

char
getch(void)
{
	char result;

	// Wait until the pipe buffer is nonempty.
	while (*PIPEBUF == 0)
		_yield(PROCESSID_C, PROCESSID_P);

	// Read the character, then clear the buffer and return.
	result = *PIPEBUF;
	*PIPEBUF = 0;
	return result;
}

int
strcmp(const char *a, const char *b)
{
	// Returns 0 if and only if the two strings, 'a' and 'b',
	// contain the same characters in the same order.
	while (*a && *b && *a == *b)
		a++, b++;
	return (int) ((unsigned char) *a) - (int) ((unsigned char) *b);
}

void
write_char(char c)
{
	// Write a character 'c' to the upper-left corner of the console,
	// then erase everything else.
	// For explanation, see 'print111os-boot.c'.
	
	int i;
	char *console = (char *) 0xB8000;
	
	console[300] = c;
	console[1] = 0x07;

	for (i = 1; i < 80 * 25; i++) {
		console[i*2] = ' ';
		console[i*2 + 1] = 0x07;
	}

	outb(0x3D4, 14);
	outb(0x3D5, 1 / 256);		// That is, 0
	outb(0x3D4, 15);
	outb(0x3D5, 1);
}

void
start(void)
{
	char buf[101];
	char output;
	int pos;

	char *console = (char *) 0xB8000;
	console[0] = 'Y';
	
	// чтение
	for (pos = 0; pos < 100; pos++) {
		char c = getch();
		// символ ('\n') 
		if (c == '\n')
			break;
		else
			buf[pos] = c;
	}
	// последний символ
	buf[pos] = 0;

	// сравниваем
	if (strcmp(buf, good_password) == 0)
		output = 'Y';
	else
		output = 'N';

	// Выводим результат
	write_char(output);

	while (1)
		_yield(PROCESSID_C, PROCESSID_P);
}
