#define PROCTBL	0x400000

/****************************************************************************
 * _yield(src_pid, dest_pid):

     управление процессами
     ID-шник source process - ID src_pid
     ID-шник  destination process - ID dest_pid
 
     Вначале для текущего процесса в стек сохраняется значение его    register state
     У процесса имеется свой указатель стека 
 
     Роль   _yield2  - сохранить в стеке программный счетчик
 
 */
	
.text
.globl _yield

_yield:		movl 4(%esp), %eax	// Load src_pid into %eax
		movl 8(%esp), %ecx	// Load dest_pid into %ecx
		pushal			// Save registers

		// Call _yield2.
		// The 'call' instruction will save the next EIP on the
		// stack, so when _yield2 begins, %esp will point to the
		// address of the 'popal' instruction.
		call _yield2

		// Control resumes here when someone yields back to this process!
		popal			// Restore registers
		ret			// Return to caller


_yield2:	// Store %esp in PROCTBL[src_pid].
		// This saves the current process's state.
		shll $2, %eax
		addl $PROCTBL, %eax	// %eax := $PROCTBL + 4*src_pid
		movl %esp, 0(%eax)

		// Load %esp from PROCTBL[dest_pid].
		shll $2, %ecx
		addl $PROCTBL, %ecx	// %ecx := $PROCTBL + 4*dst_pid
		movl 0(%ecx), %esp

		// At this point, the stack pointer points to a return
		// address within the destination process.
		// Usually that's the address of 'popal', above.
		// We can return to the destination process simply by
		// executing a 'ret' instruction!
		ret
